Subject: bug#24815: 25.1; emacs could hang whith hs-minor-mode and python-mode

From: [email-masked]
Date: Tue, 01 Nov 2016 23:57:54 -0400

tags 24815 patch
quit

[email-masked] writes:
> gives 
> "\\s-*\\(?:def\\|class\\)\\>" in version 25.1 
> instead of 
> "^\\s-*\\(?:def\\|class\\)\\>" in version 24.5 
>
> if I change it by "^\\s-*\\(?:def\\|class\\)\\>" or by 
> "\\_<\\(?:def\\|class\\)\\_>" 
> hs-minor-mode works fine with python-mode 

I guess removing the ^ would cause the issue described in #19761 to
recur, but adding \\_< makes sense.  I will apply the following patch to
emacs-25 in a few days unless there are objections.

>From df7501fbb0b076bdc9a033c0cce239adfc74560a Mon Sep 17 00:00:00 2001
From: Noam Postavsky <[email-masked]>
Date: Tue, 1 Nov 2016 23:24:33 -0400
Subject: [PATCH v1] Fix python-mode hideshow regexp

2015-02-07 "Fix hideshow integration[...]" changed the regexp added to
`hs-special-modes-alist' so that it worked when not searching from the
beginning of the line.  However, this allows matching tokens ending in
"def" or "class", not just those keywords.  This results in an infinite
loop in hs-hide-all (Bug #24815).

* lisp/progmodes/python.el (python-mode): Add symbol boundaries around
the def|class matching part of the regexp added to
hs-special-modes-alist.
---
 lisp/progmodes/python.el | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lisp/progmodes/python.el b/lisp/progmodes/python.el
index 49f7bcf..e5efc2b 100644
--- a/lisp/progmodes/python.el
+++ b/lisp/progmodes/python.el
@@ -5136,7 +5136,7 @@ python-mode
   (add-to-list
    'hs-special-modes-alist
    `(python-mode
-     "\\s-*\\(?:def\\|class\\)\\>"
+     "\\s-*\\_<\\(?:def\\|class\\)\\_>"
      ;; Use the empty string as end regexp so it doesn't default to
      ;; "\\s)".  This way parens at end of defun are properly hidden.
      ""
-- 
2.9.3